/**
 * @fileOverview  This file contains model for building searchclausesets used in user queries.
 * Consists of two parts:
 * - SearchClause model [index,relation, value], with basic functionality - 
 * creation, render, autocomplete.
 * - Searchclauseset - container of actually used searchclauses in app
 * with basic functionality for building container - add, remove, clear
 * and conversion functions - conversions from-to querystring
 *
 * @author 
 * @version 
 */

// client-side modelling of "business-objects":
// SearchClause, SearchClauseset, 

 
 //TODO use select-options or autocomplete ???
 //var  relation_autocomplete = new Array('any','all','=','>','<'); 
 //var  value_autocomplete = new Array();

/**
 * SearchClause model [index,relation, value], with basic functionality - 
 * creation, render, autocomplete.
 * @constructor
*/ 
function SearchClause(index, relation, value ) {
	this.index = index;
	this.relation = relation;	
	this.value = value;
	this.negation  = false;
	
	this.is_category = false;
	this.category = "";
	
	this.i = 0;
	this.j = 0;
	this.listid = "";
	this.container = {};
	
	if (this.relation == "") {
		this.relation = "=";
	}
	
	this.is_complex = true;
}

SearchClause.prototype.GetIndexInput = function(){
	return $($($('.sc-i','#searchclauselist')[this.i]).find('.sc-j')[this.j]).find('.index-input');
};

SearchClause.prototype.GetRelInput = function(){
	return $($($('.sc-i','#searchclauselist')[this.i]).find('.sc-j')[this.j]).find('.rel_input');
};
SearchClause.prototype.GetValueInput = function(){
	return $($($('.sc-i','#searchclauselist')[this.i]).find('.sc-j')[this.j]).find('.value-input');
};

SearchClause.prototype.GetIndexSelect = function(){
	return $($($('.sc-i','#searchclauselist')[this.i]).find('.sc-j')[this.j]).find('.index_select');
};
SearchClause.prototype.GetIndexInputTermset = function(){
	return $($($('.sc-i','#searchclauselist')[this.i]).find('.sc-j')[this.j]).find('.index-input-termset');
};
SearchClause.prototype.GetIndexInput = function(){
	return $($($('.sc-i','#searchclauselist')[this.i]).find('.sc-j')[this.j]).find('.index-input');
};


SearchClause.prototype.GetValueSelect = function(){
	return $($($('.sc-i','#searchclauselist')[this.i]).find('.sc-j')[this.j]).find('.value_select');
};

SearchClause.prototype.render = function (rel) {
	
	//TODO defaults
	//this.relation = '=';
	//var index_detail = "";
	//if ((this.i == 0) && (this.j == 0)) {
	//	index_detail = "<span name='detail_index' class='cmd cmd_detail'></span>";
	//}
	var x = "<div id='" + this.j + "' class='sc-j or_level' ><div id='" + this.listid + "' class='sc-wrapper focused' > " +
	"<div class='search'><span class='cmd cmd_sc_autocomplete cmd_sca_explain'></span><span class='index-search'><select class='index_select'/><input type='text' class='index-input-termset autocomplete-input' /><input type='text' class='index-input autocomplete-input' /></span>" + 
	//index_detail +
	//"<select type='text' class='rel_input' />" +
	"<select class='rel_input'><option value='='>=</option><option value='>'>></option><option value='<'><</option><option value='any'>any</option><option value='contains'>contains</option><option value='all'>all</option></select>" + 
	"<select class='value_select'/><input type='text' class='value-input' /><span name='detail_value' class='cmd cmd_detail'></span>" +
	 "<span class='sc_cmds'><span class='cmd cmd_sc_delete'> </span><span class='sc_id'>" + this.listid + "</span>" + 
	  "<span class='cmd cmd_add_and'> </span><span class='cmd cmd_add_or'></span>"+
	" </span></div><div class='index-context'><table></table></div></div></div>";
	
	addToSClist(x, this.i, this.j, rel);	
	
	
	var e_index = this.GetIndexInput();
	//new $.GrowingInput(e_index, {max: 80});
	var e_relation = this.GetRelInput();
	var e_value = this.GetValueInput();
	var index_select = this.GetIndexSelect();
	//var index_input_termset = this.GetIndexInputTermset();
	var value_select = this.GetValueSelect();
	
	$(index_select).hide();
	//$(index_input_term).hide();
	this.GetIndexInput().hide();
	value_select.hide();
	//$(e_index).closest('.sc-wrapper').find('.index-context').hide();
	
	//alert("focused: "  + $('.focused','#searchclauselist').size());
	$('.sc-wrapper','#searchclauselist').each(function(){
		$(this).removeClass("focused");
	});
	$(e_index).closest('.sc-wrapper').addClass("focused");
	//alert("focused: "  + $('.focused','#searchclauselist').size());
	
	// set focus
	e_index.focusin(function(){
		$('.sc-wrapper','#searchclauselist').each(function(){
			$(this).removeClass("focused");
		});
		$(this).closest('.sc-wrapper').addClass("focused");
	});
	index_select.focusin(function(){
		$('.sc-wrapper','#searchclauselist').each(function(){
			$(this).removeClass("focused");
		});
		$(this).closest('.sc-wrapper').addClass("focused");
	});
	e_relation.focusin(function(){
		$('.sc-wrapper','#searchclauselist').each(function(){
			$(this).removeClass("focused");
		});
		$(this).closest('.sc-wrapper').addClass("focused");
	});
	e_value.focusin(function(){
		$('.sc-wrapper','#searchclauselist').each(function(){
			$(this).removeClass("focused");
		});
		$(this).closest('.sc-wrapper').addClass("focused");
	});
	$($($('.sc-i','#searchclauselist')[this.i]).find('.sc-j')[this.j]).find('.cmd_detail').click(function(){
		$('.sc-wrapper','#searchclauselist').each(function(){
			$(this).removeClass("focused");
		});
		$(this).closest('.sc-wrapper').addClass("focused");
	});
	
	//TODO handle keydown
/*	e_index.keydown(function(ev){
		var evStop = function(){ ev.stopPropagation(); ev.preventDefault(); };
		if (ev.which === 13) evStop();
		var evFocusNext = function(){
			ev.preventDefault();
			e_relation.focus();	
		};
		//notifyUser($(this).attr("value").length);
		if ($(this).attr("value").length > 0 &&  ev.which === 32) evFocusNext(); // focus next element
		
	});
	
	e_relation.keydown(function(ev){
		var evStop = function(){ ev.stopPropagation(); ev.preventDefault(); };
		if (ev.which === 13) evStop();
		var evFocusNext = function(){
			e_value.focus();	
		};
		if (ev.which === 32) evFocusNext(); // focus next element
		notifyUser(ev.which);
	});
*/
	
	//selects for the first use
	index_select.change(function(){
		$(this).next().val($(this).find('option:selected').text());
		$(this).hide();
		$(this).next().show();
	});
	value_select.change(function(){
		$(this).next().val($(this).find('option:selected').text());
		$(this).hide();
		$(this).next().show();
	});
	
	e_index.val(this.index);
	e_relation.val(this.relation);
	e_value.val(this.value);
	//update after text change
	e_index.bind('change', function(){
		
		var i = $(this).closest('.sc-i').attr("id");
		var j = $(this).closest('.sc-j').attr("id");
		//alert("e-index-chabge;" + i + j + $(this).val());
		searchclauseset.searchclauses[i][j].index = $(this).val();
		notifyUser("index_sc" + i + "-" + j + " changed to:" + searchclauseset.searchclauses[i][j].index, "debug");
		searchclauseset.searchclauses[i][j].is_category = false;
    });
	e_relation.change(function(){
		var i = $(this).closest('.sc-i').attr("id");
		var j = $(this).closest('.sc-j').attr("id");
		//notifyUser("rel change:" + $(this).val(), 'debug');
		searchclauseset.searchclauses[i][j].relation = $(this).val();
		
		searchclauseset.searchclauses[i][j].is_category = false;
	});
	e_value.change(function(){
		var i = $(this).closest('.sc-i').attr("id");
		var j = $(this).closest('.sc-j').attr("id");
		searchclauseset.searchclauses[i][j].value = $(this).val();
		
		searchclauseset.searchclauses[i][j].is_category = false;
	});
	
	try{
		this.initAutocomplete(false);
		this.initAutocomplete(true);
	} catch (e){
		notifyUser("autocomplete failed: " + e.message);
	}
	
 };
 

 SearchClause.prototype.initAutocomplete = function(is_explain){
	
	 if (is_explain){
			if (element_autocomplete_explain.length == 0) return;
			 
			$(this.GetIndexInputTermset()).autocomplete({
					source: element_autocomplete_explain,
					autoFill:true,
					width:150,
					//onFindValue:findValueTermset,
					//onItemSelect:selectItemTermset,
					minLength: 0,
					matchContains:true,
					delay: 0,
					select: function( event, ui ) {
						$(this).data("item", ui.item);
						selectItemTermsetExplain(ui.item);
					}
				}).data( "autocomplete" )._renderItem = function( ul, item ) { 
					var t, re;
					if (this.term == ""){
						t = item.value;
					} else {
						re = new RegExp(this.term + "+") ; 
					    t = item.value.replace(re,"<span style='font-weight:bold;color:Blue;'>" +  
					            this.term +  
					            "</span>"); 
					}
					
				    return $( "<li></li>" ) 
				        .data( "item.autocomplete", item ) 
				        .append( "<a>" + t + "</a>" ) 
				        .appendTo( ul ); 
			}; 

	 } else {
			if (element_autocomplete.length == 0) return;
			 
			$(this.GetIndexInputTermset()).autocomplete({
					source: element_autocomplete,
					autoFill:true,
					width:150,
					//onFindValue:findValueTermset,
					//onItemSelect:selectItemTermset,
					minLength: 0,
					matchContains:true,
					delay: 0,
					select: function( event, ui ) {
						$(this).data("item", ui.item);
						selectItemTermset(ui.item);
					}
				}).data( "autocomplete" )._renderItem = function( ul, item ) { 
					var t, re;
					if (this.term == ""){
						t = item.value;
					} else {
						re = new RegExp(this.term + "+") ; 
					    t = item.value.replace(re,"<span style='font-weight:bold;color:Blue;'>" +  
					            this.term +  
					            "</span>"); 
					}
					
				    return $( "<li></li>" ) 
				        .data( "item.autocomplete", item ) 
				        .append( "<a>" + t + "</a>" ) 
				        .appendTo( ul ); 
			}; 

	 }
	$('body').find('.ac_results').css({'z-index' : '1000'});
	 
 };


SearchClause.prototype.CreateSelect = function(str, element){
	var index_select = GetIndexSelect();
	var index_input  = GetIndexInput();
	index_select.show();
	var x = "<option value='" + str + "'>" + str + "</option>";
	$(element).each(function(){
		x = x+"<option value='" + $(this).text() + "'>" + $(this).text() + "</option>";
	});
	index_select.html(x);
	
	index_input.hide();
	
};

SearchClause.prototype.PlainText = function(){ 
	if (this.index.trim().length == 0 || this.value.trim().length == 0){
		return "";
	}
	if (this.is_category){
			return "ISOCAT( " + this.category + ") " + this.relation + " " + this.value;
	}
	return this.index.trim().replace(" ","_") + " " + this.relation + " " + this.value;
};

/** special handling for special characters: double escaping (escape the %-sign)
 * to survive the %-encoding through the request (and parsing) down to the transformation in XCQL2XPath.xsl
 * it's: whitespace, and single and double-quotes (unified to double quotes %22)
*/ 
SearchClause.prototype.escape = function(){
	var escape_string = "";
	var escape_value_string = "";
	
	escape_value_string =escape(this.value).replace(/%20/g,"%2520").replace(/\%2[27]/g,"%2522").replace(/%7C/g,"%257C").replace(/\+/g,"%2B"); 

	if (this.is_complex) {
		escape_string = escape_string + escape(this.index.trim().replace(" ","_") + " " + this.relation + " ") + escape_value_string;
	} else {
		// case more simple words in search
		escape_string = escape_value_string;
	}	
	return escape_string;
	
};

SearchClause.createFromData = function(scstr){
	var n;
	var scarr;
	var rel = "";
	n = scstr.indexOf("=");
	if (n > 0){
		scarr = scstr.split("=");
		rel = "=";
	}
	n = scstr.indexOf(" any ");
	if (n > 0){
		scarr = scstr.split(" any ");
		rel = "any";
	}
	n = scstr.indexOf(" contains ");
	if (n > 0){
		scarr = scstr.split(" contains ");
		rel = "contains";
	}
	n = scstr.indexOf("<");
	if (n > 0){
		scarr = scstr.split("<");
		rel = "<";
	}
	n = scstr.indexOf(">");
	if (n > 0){
		scarr = scstr.split(">");
		rel = ">";
	}
	n = scstr.indexOf(" all ");
	if (n > 0){
		scarr = scstr.split(" all ");
		rel = "all";
	}
	//notifyUser("scarr:" + scarr[0] + scarr[1],'debug');
	
	if (scarr == undefined) {
		//this.issimpletext = true;
		sc = new SearchClause('*','any',scstr);
		sc.is_complex = false;
	} else {
		//this.issimpletext = false;
		sc = new SearchClause(scarr[0],rel,scarr[1]);
		sc.is_complex = true;
	}

	return sc;
};
/*
Searchclause.prototype.submit = function () {
	
	var uri = link('recordset','htmltable', this.query_uri());
	notifyUser("submitting query:" +  uri);
	
	this.container.find('.result').load( uri, function() {
				notifyUser("result-loaded");
				var get = $(this).parent().find('.cmd_get');				

				get.removeClass('cmd_get');
				get.addClass('cmd_up');
				// get.show();
			});

}
*/
    
$('.index-context td').live('click',  function(event) {
	
	searchclauseset.updatedata(this.textContent, false, "");
	//$('.focused','#searchclauselist').find('.index-input').val(	this.textContent);
	$('.focused','#searchclauselist').find('.index-context').hide();
	
	$('.focused','#searchclauselist').find('.value-input').focus();

});


var searchclauseset_container = $("#searchclauselist"); 

/**
 * container of actually used Searchclauses in the query-input
 * with basic functionality for building container - add, remove, clear
 * and conversion functions - conversions from-to querystring
 * @constructor 
 */

var searchclauseset = {
		/**  @field */
	searchclauses: [],
	container: '#searchclauselist',
	sctext: '',
		
	addsearchclause: function (searchclause, rel, _i, _j){
		var i,j;
			
		if (this.searchclauses.length == 0){
			i = 0;
			this.searchclauses[i] = new Array();
			j = 0;
		} else {
			if (rel == "or") {
				i = _i;//this.searchclauses.length - 1;
				j = this.searchclauses[i].length;//this.searchclauses[this.searchclauses.length - 1].length;
			} else {
				i = this.searchclauses.length;
				this.searchclauses[i] = new Array();
				j = 0;
			}
		}
		searchclause.i = i;
		searchclause.j = j;
		searchclause.listid = "sc" + i + "-" + j;
		this.searchclauses[i][j] = searchclause;
		
		searchclause.render(rel);						
		//$('#querylist').html(this.render());
	},
	
	fillFromURL: function(url){
	},
	
	clear: function() {
		notifyUser("clear query",'debug');
		
		for (var i = this.searchclauses.length - 1; i > -1; i--){
			for (var j = this.searchclauses[i].length - 1; j > -1; j--){
			

					this.searchclauses[i].splice(j, 1);
					if  (j == 0){
						this.searchclauses.splice(i, 1);
						$('#' + 'sc' +  i + '-' + j).parent().parent().remove();
						$('#' + 'sc' +  i + '-' + j).parent().remove();
					} else {
						$('#' + 'sc' +  i + '-' + j).parent().remove();
					}		
		
			
			}
		}
		
		notifyUser(this.searchclauses.length,'debug');
		
		// reset focused
		//$('.sc-wrapper','#searchclauselist').each(function(){
		//	$(this).removeClass("focused");
		//});
		//$('#sc0-0').addClass("focused");
	},
	
	//TODO remove only last items
	removesearchclause: function (i, j) {
		notifyUser("removing sc:"  + i + "," + j,'debug');
		
		if ((j == 0) && (i == 0)){
			searchclauseset.searchclauses[i][j].index = "";
			searchclauseset.searchclauses[i][j].is_category = false;
			searchclauseset.searchclauses[i][j].relation = "=";
			searchclauseset.searchclauses[i][j].value = "";
			$('#sc0-0').find('.index-input').val("");
			$('#sc0-0').find('.index-input-termset').val("");
			$('#sc0-0').find('.rel_input').val("=");
			$('#sc0-0').find('.value-input').val("");			
			notifyUser("cannot remove", 'debug');
			return;
		}
		if ((j == 0) && (i < this.searchclauses.length - 1)){
			notifyUser("cannot remove",'debug');
			return;
		}
		if (j < this.searchclauses[i].length - 1){
			notifyUser("cannot remove",'debug');
			return;
		}
		this.searchclauses[i].splice(j, 1);
		 
		if  (j == 0){
			this.searchclauses.splice(i, 1);
			$('#' + 'sc' +  i + '-' + j).parent().parent().remove();
		} else {
			$('#' + 'sc' +  i + '-' + j).parent().remove();
		}		

		notifyUser("sc removed, new sc.length:"  + this.searchclauses.length,'debug');
		for (var j = 0; j < this.searchclauses.length; j++) {
			notifyUser("  new sc.or_length:"  + this.searchclauses[j].length,'debug');
		}	
		// reset focused
		$('.sc-wrapper','#searchclauselist').each(function(){
			$(this).removeClass("focused");
		});
		$('#sc0-0').addClass("focused");
		
	},
	/*
	// just test
	load: function(i,j,rel,data) {
		if (data["triple"] == null ) {
			 this.searchclauses[i][j].index =  data["searchClause"]["index"];
			 this.searchclauses[i][j].relation =  data["searchClause"]["relation"]["value"];
			 this.searchclauses[i][j].value =  data["searchClause"]["term"];
			 
			 $('#sc0-0','#searchclauselist').find('.index-input').val(data["searchClause"]["index"]);
			 $('#sc0-0','#searchclauselist').find('.relation_input').val(data["searchClause"]["relation"]["value"]);
			 $('#sc0-0','#searchclauselist').find('.value-input').val(data["searchClause"]["term"]);
		 } else {
			 if (data["triple"]["boolean"]["value"] == "and") {
				 //var sc = new SearchClause("","","");
				 //this.addsearchclause(sc, "and", _i, _j)
				 // update(leftO)
				 // update(rightO)
				 load(i,j,"",data["triple"]["leftOperand"]);
				 i = this.searchclauses.length;
				 load(i+1,j,"and",data["triple"]["rightOperand"]);
			 } else {
				 load(i,j,"",data["triple"]["leftOperand"]);
				 j = this.searchclauses[i].length;
				 load(i,j,"or",data["triple"]["rightOperand"]);
			 }
			 
		 }
		 
	},
	*/
	// from querystring to searchclauses
	buildfromquerystring: function(){
		var arr = Query.simplequerystring(this.sctext);
		var sc, screl;
		
		this.clear();
		
		//notifyUser(arr,'debug');
		var arr_and = arr.split(" and ");
		screl = "";
		for( var i=0;i<arr_and.length;i++){
			var scstring = $.trim(arr_and[i]);
			
			if (scstring.substring(0,1) == "(" && scstring.substring(scstring.length-1) == ")") {
				scstring = scstring.substring(1,scstring.length-1);
				scstring = $.trim(scstring);
			}
			
			//notifyUser("i:" + scstring,'debug');
			var arr_or = scstring.split(" or ");
			if (i > 0) {screl = "and";}
			for( var j=0;j<arr_or.length;j++){
				if (j > 0) {screl = "or";}
				
				sc = SearchClause.createFromData($.trim(arr_or[j]));
				this.addsearchclause(sc,screl,i,j);				
			}
		}
	},
	
	
	buildsctext: function(){
	   var uncompletequery = false;
	   var ptext = "";
	   
		if ($('.searchtype_text','#search').size() > 0) {
			this.sctext = $('#query_area').val();
		} else {
		
			this.sctext = "";
			for (var i = 0; i < this.searchclauses.length; i++) {
				if ( i>0) this.sctext = this.sctext + " and ";
				if (this.searchclauses.length> 1) this.sctext = this.sctext + " ( ";
				for (var j = 0; j < this.searchclauses[i].length; j++) {
					if ( j>0) this.sctext = this.sctext + " or ";
					if (this.searchclauses[i].length > 1) this.sctext = this.sctext + " ( ";
					ptext = this.searchclauses[i][j].PlainText();
					if (ptext.length == 0){
						uncompletequery = true;
					}
					this.sctext = this.sctext + ptext;
					if (this.searchclauses[i].length > 1) this.sctext = this.sctext + " ) ";
				}
				if (this.searchclauses.length> 1) this.sctext = this.sctext + " ) ";
			}
			
		}	
		if ((i == 1 && j == 1) && (this.sctext.substring(0,6) == '* any ')) {
			this.sctext  = this.sctext.replace('* any ','');
		}
		if (uncompletequery){
			this.sctext = "";
		}
		notifyUser(this.sctext);
		return this.sctext;
		
	},
	
	updatedata: function(term, is_category, category, value) {	 
		
		var i = $('.focused','#searchclauselist').closest('.sc-i').attr("id");
		var j = $('.focused','#searchclauselist').closest('.sc-j').attr("id");
		
		if (term != undefined){
			$('.focused','#searchclauselist').find('.index-input').val(term);
			searchclauseset.searchclauses[i][j].index = term.replace(" ","_");
		}
		
		if (value == undefined){
			$('.focused','#searchclauselist').find('.value-input').focus();
		} else {
			$('.focused','#searchclauselist').find('.value-input').val(value);
			searchclauseset.searchclauses[i][j].value = value;
		}
		
		if (is_category) {
			searchclauseset.searchclauses[i][j].is_category = true;
			searchclauseset.searchclauses[i][j].category = category;
		} else {
			searchclauseset.searchclauses[i][j].is_category = false;
		}
		
	},
	
	initAutocomplete: function(is_explain) {
		notifyUser("init autocomplete",'debug');
		
		for (var i = this.searchclauses.length - 1; i > -1; i--){
			for (var j = this.searchclauses[i].length - 1; j > -1; j--){
					this.searchclauses[i][j].initAutocomplete(is_explain);		
			}
		}	
	}
};

function escapequerystring(querystring){
	var arr = Query.simplequerystring(querystring);
	var sc, screl;
	var escape_string = "";
	var add_bracket = false;
	
	//notifyUser(arr,'debug');
	var arr_and = arr.split(" and ");
	screl = "";
	for( var i=0;i<arr_and.length;i++){
		var scstring = $.trim(arr_and[i]);
		
		add_bracket = false;
		if (scstring.substring(0,1) == "(" && scstring.substring(scstring.length-1) == ")") {
			scstring = scstring.substring(1,scstring.length-1);
			scstring = $.trim(scstring);
			escape_string = escape_string + "(";
			add_bracket = true;
		}
		
		//notifyUser("i:" + scstring,'debug');
		var arr_or = scstring.split(" or ");
		if (i > 0) {screl = "and";}
		
		for( var j=0;j<arr_or.length;j++){
			var scstr = $.trim(arr_or[j]);		
			if (j > 0) {screl = "or";}
			
			sc = SearchClause.createFromData(scstr);
			if (screl != ""){
				escape_string  = escape_string + "%20" + screl + "%20";
			}
			escape_string = escape_string + sc.escape();
		}
		if (add_bracket){
			escape_string = escape_string + ")";
		}
	}
	return escape_string;
}



//autocomplete
	
function findValueValue(e) {
	var i = $('.focused','#searchclauselist').closest('.sc-i').attr("id");
	var j = $('.focused','#searchclauselist').closest('.sc-j').attr("id");
	//alert(i+ ',' + j + sValue);
	var termsetitem = $('#' + 'sc' +  i + '-' + j).find('.value-input').data('item');
	var termset = "";
	if (termsetitem != null) termset = termsetitem.key;
	searchclauseset.searchclauses[i][j].value = e.value;
	
}
function selectItemValue(li) {
	findValueValue(li);
}

function initValueAutocomplete(i,j,index, term_index){
	
	$('#' + 'sc' +  i + '-' + j).find('.value-input').autocomplete({
		source: element_autocomplete[index].data[term_index].values,
		autoFill:true,
		width:150,
		minLength: 0,
		matchContains:true,
		delay: 0,
		select: function( event, ui ) {
			$(this).data("item", ui.item);
			selectItemValue(ui.item);
		}
	}).data( "autocomplete" )._renderItem = function( ul, item ) { 
		var t, re;
		if (this.term == ""){
			t = item.value;
		} else {
			re = new RegExp(this.term + "+") ; 
		    t = item.value.replace(re,"<span style='font-weight:bold;color:Blue;'>" +  
		            this.term +  
		            "</span>"); 
		}
		
	    return $( "<li></li>" ) 
	        .data( "item.autocomplete", item ) 
	        .append( "<a>" + t + "</a>" ) 
	        .appendTo( ul ); 
	};

	
	// reset the index value
	$('#' + 'sc' +  i + '-' + j).find('.value-input').val("");
	searchclauseset.searchclauses[i][j].value = "";
	$('#' + 'sc' +  i + '-' + j).find('.value-input').show();
	$('body').find('.ac_results').css({'z-index' : '1000'});
	
	
	$('.focused','#searchclauselist').find('.value-input').focus();

	
};
function initValueAutocompleteExplain(i,j,index, term_index){
	
	// reset the index value
	$('#' + 'sc' +  i + '-' + j).find('.value-input').val("");
	searchclauseset.searchclauses[i][j].value = "";
	$('#' + 'sc' +  i + '-' + j).find('.value-input').show();
	$('body').find('.ac_results').css({'z-index' : '1000'});
	
	
	$('.focused','#searchclauselist').find('.value-input').focus();

	
};

function findValueTerm(e) {
	
	//var sValue = e.selectValue;
	
	var i = $('.focused','#searchclauselist').closest('.sc-i').attr("id");
	var j = $('.focused','#searchclauselist').closest('.sc-j').attr("id");
	//alert(i+ ',' + j + sValue);
	var sClause = $('#' + 'sc' +  i + '-' + j);
	var context = "";
	var termsetitem = $(sClause).find('.index-input-termset').data('item');
	var termset = "";
	if (termsetitem != null) termset = termsetitem.key;
	var str = e.id;
	str = str.substring(str.lastIndexOf('/')+1, str.length);
	var termsetindex = termset + ":" +  str;
	searchclauseset.searchclauses[i][j].index = termsetindex;
	
	//handleTermsSelection(i,j,sValue);	
	//find element value

	var index;
	$.each(element_autocomplete,function(i, item){
		if (this.key == termset){
			index = i;
			return;
		}
	});
	var term_index;
	
	$.each(element_autocomplete[index].data,function(i, item){
		if (this.id == e.id){
			term_index = i;
			return;
		}
	});
	if (element_autocomplete[index].data[term_index].values.length == 0){
		jQuery.get(link('fcs','?operation=scan&scanClause' + termsetindex + '&x-context=' + getSelectedRepository()),function(data){
		$(data).find("sru\\:term").each(function(i){
			element_autocomplete[index].data[term_index].values[i] = {label:$(this).find('sru\\:value').text()};
		});
		initValueAutocomplete(i,j, index, term_index);
		});
	} else {
		initValueAutocomplete(i,j, index, term_index);
	}	
}
function findValueTermExplain(e) {
	
	//var sValue = e.selectValue;
	
	var i = $('.focused','#searchclauselist').closest('.sc-i').attr("id");
	var j = $('.focused','#searchclauselist').closest('.sc-j').attr("id");
	//alert(i+ ',' + j + sValue);
	var sClause = $('#' + 'sc' +  i + '-' + j);
	var context = "";
	var termsetitem = $(sClause).find('.index-input-termset').data('item');
	var termset = "";
	if (termsetitem != null) termset = termsetitem.key;
	var str = e.id;
	str = str.substring(str.lastIndexOf('/')+1, str.length);
	var termsetindex = termset + ":" +  str;
	searchclauseset.searchclauses[i][j].index = termsetindex;
	
	//find element value

	var index;
	$.each(element_autocomplete_explain,function(i, item){
		if (this.key == termset){
			index = i;
			return;
		}
	});
	var term_index;
	
	$.each(element_autocomplete_explain[index].data,function(i, item){
		if (this.id == e.id){
			term_index = i;
			return;
		}
	});
	if (element_autocomplete_explain[index].data[term_index].values.length == 0){
		jQuery.get(link('fcs','?operation=scan&scanClause' + termsetindex + '&x-context=' + getSelectedRepository()),function(data){
		$(data).find("sru\\:term").each(function(i){
			element_autocomplete[index].data[term_index].values[i] = {label:$(this).find('sru\\:value').text()};
		});
		initValueAutocompleteExplain(i,j, index, term_index);
		});
	} else {
		initValueAutocompleteExplain(i,j, index, term_index);
	}	
}
 
function selectItemTerm(li) {
	findValueTerm(li);
}
function selectItemTermExplain(li) {
	findValueTermExplain(li);
}

function initTermsetAutocomplete(i,j,index){

	$('#' + 'sc' +  i + '-' + j).find('.index-input').autocomplete({
		source: element_autocomplete[index].data,
		autoFill:true,
		width:150,
		minLength: 0,
		matchContains:true,
		delay: 0,
		select: function( event, ui ) {
			$(this).data("item", ui.item);
			selectItemTerm(ui.item);
			}
	}).data( "autocomplete" )._renderItem = function( ul, item ) { 
		var t, re;
		if (this.term == ""){
			t = item.value;
		} else {
			re = new RegExp(this.term + "+") ; 
		    t = item.value.replace(re,"<span style='font-weight:bold;color:Blue;'>" +  
		            this.term +  
		            "</span>"); 
		}
	
		return $( "<li></li>" ) 
		    .data( "item.autocomplete", item ) 
		    .append( "<a>" + t + "</a>" ) 
		    .appendTo( ul ); 
	};
	
	
		// reset the index value
	$('#' + 'sc' +  i + '-' + j).find('.index-input').val("");
	searchclauseset.searchclauses[i][j].index = "";
	$('#' + 'sc' +  i + '-' + j).find('.value-input').val("");
	searchclauseset.searchclauses[i][j].value = "";
	$('#' + 'sc' +  i + '-' + j).find('.index-input').show();
	$('body').find('.ac_results').css({'z-index' : '1000'});
	
	
	$('.focused','#searchclauselist').find('.index-input').focus();
};
function initTermsetAutocompleteExplain(i,j,index){

	$('#' + 'sc' +  i + '-' + j).find('.index-input').autocomplete({
		source: element_autocomplete_explain[index].data,
		autoFill:true,
		width:150,
		minLength: 0,
		matchContains:true,
		delay: 0,
		select: function( event, ui ) {
			$(this).data("item", ui.item);
			selectItemTermExplain(ui.item);
			}
	}).data( "autocomplete" )._renderItem = function( ul, item ) { 
		var t, re;
		if (this.term == ""){
			t = item.value;
		} else {
			re = new RegExp(this.term + "+") ; 
		    t = item.value.replace(re,"<span style='font-weight:bold;color:Blue;'>" +  
		            this.term +  
		            "</span>"); 
		}
	
		return $( "<li></li>" ) 
		    .data( "item.autocomplete", item ) 
		    .append( "<a>" + t + "</a>" ) 
		    .appendTo( ul ); 
	};
	
	
		// reset the index value
		$('#' + 'sc' +  i + '-' + j).find('.index-input').val("");
		searchclauseset.searchclauses[i][j].index = "";
		$('#' + 'sc' +  i + '-' + j).find('.index-input').show();
		$('body').find('.ac_results').css({'z-index' : '1000'});
	
	
		$('.focused','#searchclauselist').find('.index-input').focus();
};


function findValueTermset(elem) {
	//var sValue = e.selectValue;

	var i = $('.focused','#searchclauselist').closest('.sc-i').attr("id");
	var j = $('.focused','#searchclauselist').closest('.sc-j').attr("id");

	//searchclauseset.searchclauses[i][j].index = sValue;	
	//handleTermsetSelection(i,j,sValue);		

	//find element
	var index;
	$.each(element_autocomplete,function(i, item){
		if (this.key == elem.key){
			index = i;
			return;
		}
	});

	if (element_autocomplete[index].data.length == 0){
		jQuery.get(link('smc','list/?context=' + element_autocomplete[index].key),function(data){
			$(data).find('Term').each(function(i){
				element_autocomplete[index].data[i] = {label:$(this).text(), value:$(this).text(), id:$(this).attr("concept-id"),values:[] };
			});
			initTermsetAutocomplete(i,j, index);
		});
	} else {
		initTermsetAutocomplete(i,j, index);
	}
}
function findValueTermsetExplain(elem) {
	
	var i = $('.focused','#searchclauselist').closest('.sc-i').attr("id");
	var j = $('.focused','#searchclauselist').closest('.sc-j').attr("id");

		//find element
	var index;
	$.each(element_autocomplete_explain,function(i, item){
		if (this.key == elem.key){
			index = i;
			return;
		}
	});

	if (element_autocomplete_explain[index].data.length == 0){
		jQuery.get(link('fcs','?operation=explain&x-context=' + getSelectedRepository()),function(data){
			$(data).find('indexInfo').children('index').children('map').children('name[set='+ element_autocomplete_explain[index].key +']').each(function(i){
				element_autocomplete_explain[index].data[i] = {label:$(this).text(), value:$(this).text(), id:$(this).text(),values:[] };
			});
			initTermsetAutocompleteExplain(i,j, index);
		});
	} else {
		initTermsetAutocompleteExplain(i,j, index);
	}

}


function selectItemTermset(li) {
	findValueTermset(li);
	}
function selectItemTermsetExplain(li) {
	findValueTermsetExplain(li);
	}

